//BrainStorm mkH

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import java.util.*;
import java.lang.Math;
import java.io.*;

class Objekt
{
	
	//Attribute
	static boolean objekt_info_offen;
	Info   objekt_info;
	String objekt_stereotyp;
	String objekt_klasse;
	String objekt_eigenschaftswerte;
	Vector objekt_attribute;
	Vector objekt_methoden;
	
	//Konstruktor
	Objekt()
	{
		objekt_info_offen=false;
		objekt_info=new Info();
		objekt_stereotyp="";
		objekt_klasse="";
		objekt_eigenschaftswerte="";
		objekt_attribute=new Vector(1,1);
		objekt_methoden=new Vector(1,1);
	}
	
	//Methode: editieren
	public void edit()
	{
		Gui_Objekt my_objekt_gui = new Gui_Objekt();
		my_objekt_gui.setVisible(true);
		my_objekt_gui.pack();
	}
	
	//Methode: save
	public void save (File filename) throws Exception
	{
		XML xmlobject=new XML();		
		{
			xmlobject.writeTag("objekt",0); 
			xmlobject.writeChar("\n");
			
			objekt_info.write(xmlobject);                   
			
			xmlobject.writeTag("body",2);           
			xmlobject.writeChar("\n");
			
			xmlobject.writeTag("stereotyp",4);
			xmlobject.writeString(objekt_stereotyp);
			xmlobject.writeTag("/stereotyp",0);                           
			xmlobject.writeChar("\n");
			
			xmlobject.writeTag("klasse",4);
			xmlobject.writeString(objekt_klasse);
			xmlobject.writeTag("/klasse",0);
			xmlobject.writeChar("\n");
			
			xmlobject.writeTag("eigenschaftswerte",4);
			xmlobject.writeString(objekt_eigenschaftswerte);
			xmlobject.writeTag("/eigenschaftswerte",0);
			xmlobject.writeChar("\n");
			
			for(int count=0;count<objekt_attribute.size();count++)
			{
				xmlobject.writeTag("attribute",4);  
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("name",6);
				xmlobject.writeString(((Attribut)objekt_attribute.get(count)).attribut_name);
				xmlobject.writeTag("/name",0);
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("gueltigkeit",6);
				xmlobject.writeString(((Attribut)objekt_attribute.get(count)).attribut_gueltigkeit);
				xmlobject.writeTag("/gueltigkeit",0);
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("datentyp",6);
				xmlobject.writeString(((Attribut)objekt_attribute.get(count)).attribut_datentyp);
				xmlobject.writeTag("/datentyp",0);
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("wert",6);
				xmlobject.writeString(((Attribut)objekt_attribute.get(count)).attribut_attributwert);
				xmlobject.writeTag("/wert",0);
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("zusicherung",6);
				xmlobject.writeString(((Attribut)objekt_attribute.get(count)).attribut_zusicherung);
				xmlobject.writeTag("/zusicherung",0);
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("/attribute",4); 
				xmlobject.writeChar("\n");
			}
			
			for(int count=0;count<objekt_methoden.size();count++)
			{
				xmlobject.writeTag("methode",4);    
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("name",6);
				xmlobject.writeString(((Methode)objekt_methoden.get(count)).methode_name);
				xmlobject.writeTag("/name",0);
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("gueltigkeit",6);
				xmlobject.writeString(((Methode)objekt_methoden.get(count)).methode_gueltigkeit);
				xmlobject.writeTag("/gueltigkeit",0);
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("rueckgabetyp",6);
				xmlobject.writeString(((Methode)objekt_methoden.get(count)).methode_rueckgabetyp);
				xmlobject.writeTag("/rueckgabetyp",0);
				xmlobject.writeChar("\n");
				
				
				xmlobject.writeTag("parameter",6);
				xmlobject.writeString(((Methode)objekt_methoden.get(count)).methode_parameter);
				xmlobject.writeTag("/parameter",0);
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("zusicherung",6);
				xmlobject.writeString(((Methode)objekt_methoden.get(count)).methode_zusicherung);
				xmlobject.writeTag("/zusicherung",0);
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("/methode",4); 
				xmlobject.writeChar("\n");
			}			
			xmlobject.writeTag("/body",2);          
			xmlobject.writeChar("\n");
			xmlobject.writeTag("/objekt",0);       
			xmlobject.writeChar("\n");
			xmlobject.saveXml(filename);                     
		}
	}
	
	//Methode: load
	public void load (File filename) throws Exception
	{
		XML  	 xmlobject=new XML();
		String  tag="";
		String  maname="";
		String  magueltigkeit="";
		String  matyp="";
		String  mawert="";
		String  mazusicherung="";
		
		objekt_info.filename=filename.getPath();
		
		xmlobject.loadXml(filename);//XML Datei komplett in den Dateipuffer lesen               					
		tag=xmlobject.getTag();		 //hole erstes Tag aus dem Buffer			
		if (!tag.equals("objekt"))  //wenn das nicht <objekt> ist dann ist das auch keine ObjektXMLDatei
		{			
			throw new Exception("Diese Datei enthaelt kein Objekt");			
		}			
		
		do
		{
			tag=xmlobject.getTag();			
			if (tag.equals("header"))
			{												
				objekt_info.read(xmlobject);				
			}							
			else
			{
				if (tag.equals("body"))				
				{					
					do
					{
						tag=xmlobject.getTag();
						if (tag.equals("stereotyp")) 
						{							
							if(!objekt_stereotyp.equals(""))
							{
								throw new Exception("Fehler in der XML-Datei: Doppeltes Tag <stereotyp>");
							}
							else
							{				
								objekt_stereotyp=xmlobject.getString("stereotyp");						
							}
						}									
						else
						{
							if (tag.equals("klasse"))
							{								
								if(!objekt_klasse.equals(""))
								{
									throw new Exception("Fehler in der XML-Datei: Doppeltes Tag <klasse>");	
								}
								else
								{								
									objekt_klasse=xmlobject.getString("klasse");								
								}									
							}
							else
							{
								if (tag.equals("eigenschaftswerte"))
								{									
									if(!objekt_eigenschaftswerte.equals(""))
									{
										throw new Exception("Fehler in der XML-Datei: Doppeltes Tag <eigenschaftswerte>");
									}
									else
									{									
										objekt_eigenschaftswerte=xmlobject.getString("eigenschaftswerte");
									}
								}									
								else
								{
									if (tag.equals("attribute"))
									{																											
										maname="";
										magueltigkeit="";
										matyp="";
										mawert="";
										mazusicherung="";
		
										do
										{
											tag=xmlobject.getTag();
											if (tag.equals("name"))
											{																					
												if(!maname.equals(""))
												{
													throw new Exception("In einem <attribute>-Tag gibt es mehr als 1 <name>-Tag, es ist aber nur 1 <name>-Tag erlaubt");
												}
												else
												{
													maname=xmlobject.getString("name");
												}
											}
											else
											{
												if (tag.equals("gueltigkeit"))
												{													
													if(!magueltigkeit.equals(""))
													{
														throw new Exception("In einem <attribute>-Tag gibt es mehr als 1 <gueltigkeit>-Tag, es ist aber nur 1 <gueltigkeit>-Tag erlaubt");
													}
													else
													{
														magueltigkeit=xmlobject.getString("gueltigkeit");
													}														
												}
												else
												{							
													if (tag.equals("datentyp"))
													{														
														if(!matyp.equals(""))
														{
															throw new Exception("In einem <attribute>-Tag gibt es mehr als 1 <datentyp>-Tag, es ist aber nur 1 <datentyp>-Tag erlaubt");
														}
														else
														{
															matyp=xmlobject.getString("datentyp");
														}														
													}
													else
													{																		
														if (tag.equals("wert"))
														{															
															if(!mawert.equals(""))
															{
																throw new Exception("In einem <attribute>-Tag gibt es mehr als 1 <wert>-Tag, es ist aber nur 1 <wert>-Tag erlaubt");
															}
															else
															{
																mawert=xmlobject.getString("wert");
															}															
														}
														else
														{																			
															if (tag.equals("zusicherung"))
															{																
																if(!mazusicherung.equals(""))
																{
																	throw new Exception("In einem <attribute>-Tag gibt es mehr als 1 <zusicherung>-Tag, es ist aber nur 1 <zusicherung>-Tag erlaubt");	
																}
																else
																{
																	mazusicherung=xmlobject.getString("zusicherung");
																}
															}
															else
															{																				
																if (!tag.equals("/attribute"))
																{																																		
																	xmlobject.skipTag(tag);
																}													
															}
														}
													}
												}
											}
										}  while(!tag.equals("/attribute"));							
										
										Attribut aktuelles_Attribut=new Attribut();
										aktuelles_Attribut.attribut_name=maname;
										aktuelles_Attribut.attribut_gueltigkeit=magueltigkeit;
										aktuelles_Attribut.attribut_datentyp=matyp;
										aktuelles_Attribut.attribut_attributwert=mawert;
										aktuelles_Attribut.attribut_zusicherung=mazusicherung;						
										objekt_attribute.addElement(aktuelles_Attribut);							
									}						
									else 
									{
										if (tag.equals("methode"))
										{																				
											maname="";
											magueltigkeit="";
											matyp="";
											mawert="";
											mazusicherung="";
		
											do
											{
												tag=xmlobject.getTag();
												if (tag.equals("name"))
												{													
													if(!maname.equals(""))
													{
														throw new Exception("In einem <methode>-Tag gibt es mehr als 1 <name>-Tag, es ist aber nur 1 <name>-Tag erlaubt");
													}														
													else
													{
														maname=xmlobject.getString("name");
													}													
												}												
												else 
												{
													if(tag.equals("gueltigkeit"))
													{														
														if(!magueltigkeit.equals(""))
														{
															throw new Exception("In einem <methode>-Tag gibt es mehr als 1 <gueltigkeit>-Tag, es ist aber nur 1 <gueltigkeit>-Tag erlaubt");
														}
														else
														{
															magueltigkeit=xmlobject.getString("gueltigkeit");
														}														
													}	
													else
													{
														if (tag.equals("rueckgabetyp"))
														{															
															if(!matyp.equals(""))
															{
																throw new Exception("In einem <methode>-Tag gibt es mehr als 1 <rueckgabetyp>-Tag, es ist aber nur 1 <rckgabetyp>-Tag erlaubt");
															}
															else
															{
																matyp=xmlobject.getString("rueckgabetyp");
															}															
														}
														else 
														{
															if (tag.equals("parameter"))
															{																
																if(!mawert.equals(""))
																{
																	throw new Exception("In einem <methode>-Tag gibt es mehr als 1 <parameter>-Tag, es ist aber nur 1 <parameter>-Tag erlaubt");
																}
																else
																{
																	mawert=xmlobject.getString("parameter");
																}																
															}
															else 
															{
																if (tag.equals("zusicherung"))
																{																	
																	if(!mazusicherung.equals(""))
																	{
																		throw new Exception("In einem <methode>-Tag gibt es mehr als 1 <zusicherung>-Tag, es ist aber nur 1 <zusicherung>-Tag erlaubt");
																	}
																	else
																	{
																		mazusicherung=xmlobject.getString("zusicherung");
																	}
																}
																else
																{
																	if (!tag.equals("/methode"))
																	{																																				
																		xmlobject.skipTag(tag);
																	}
																}
															}
														}
													}
												}										
											} while(!tag.equals("/methode"));									
											Methode aktuelle_Methode=new Methode();
											aktuelle_Methode.methode_name=maname;
											aktuelle_Methode.methode_gueltigkeit=magueltigkeit;
											aktuelle_Methode.methode_rueckgabetyp=matyp;
											aktuelle_Methode.methode_parameter=mawert;
											aktuelle_Methode.methode_zusicherung=mazusicherung;
											objekt_methoden.addElement(aktuelle_Methode);							
										} /*if (tag.equals("methode"))*/
										else							
										{
											if (!tag.equals("/body"))
											{												
												xmlobject.skipTag(tag);
											}
										}
									} /* else von if (tag.equals("attribute"))*/
								}/* else if (tag.equals("eigenschaftswerte"))*/
							}/* else von if (tag.equals("klasse"))*/
						}/* else von if (tag.equals("stereotyp"))*/ 			 
					}while (!tag.equals("/body"));					
				} /*if tag.equals("body")*/											
			} /*else wenns kein header ist*/
		} while(!tag.equals("/objekt")); 
		edit();//rufe nun die EDIT-Methode von Objekt auf
	} /*load*/
	
	//Datentyp: Methode eines Objekts
	private class Methode
	{
		String methode_name;
		String methode_gueltigkeit;
		String methode_rueckgabetyp;
		String methode_parameter;
		String methode_zusicherung;
		
		Methode()
		{
			methode_name="";
			methode_gueltigkeit="";
			methode_rueckgabetyp="";
			methode_parameter="";
			methode_zusicherung="";
		}
	}
	
	//Datentyp: Attribut eines Objekts
	private class Attribut
	{
		String attribut_name;
		String attribut_gueltigkeit;
		String attribut_datentyp;
		String attribut_attributwert;
		String attribut_zusicherung;
		
		Attribut()
		{
			attribut_name="";
			attribut_gueltigkeit="";
			attribut_datentyp="";
			attribut_attributwert="";
			attribut_zusicherung="";
		}
	}
	
	//GUI 
	class Gui_Objekt extends JFrame
	{
		final JFileChooser fc = new JFileChooser();
		
		JPanel content_pane = new JPanel();
		
		JPanel left = new JPanel();
		JPanel right = new JPanel();
		
		JPanel right_buttons = new JPanel();
		
		JPanel one1 = new JPanel();
		JPanel one11 = new JPanel();
		JPanel one2 = new JPanel();
		JPanel oneall = new JPanel();
		
		JPanel two1 = new JPanel();
		JPanel two2 = new JPanel();
		JPanel two21 = new JPanel();
		JPanel two22 = new JPanel();
		JPanel two3 = new JPanel();
		JPanel two31 = new JPanel();
		JPanel twoall = new JPanel();
		
		JPanel three1 = new JPanel();
		JPanel three2 = new JPanel();
		JPanel three21 = new JPanel();
		JPanel three22 = new JPanel();
		JPanel three3 = new JPanel();
		JPanel three31 = new JPanel();
		JPanel threeall = new JPanel();
		
		String objekt = "";
		String stereo = "";
		String klasse = "";
		String eigen = "";
		
		JSplitPane my_splitter = new JSplitPane(1, left, right);
		
		Vector my_attributes = new Vector(1,1);
		Vector my_methods = new Vector(1,1);
		
		JList attribute_list = new JList(my_attributes);
		JList method_list = new JList(my_methods);
		
		JScrollPane scroll_attributes = new JScrollPane(attribute_list);
		JScrollPane scroll_methods = new JScrollPane(method_list);
		
		//TextFields des Reiters "Allgemein"
		JTextField object_name = new JTextField(objekt_info.info_name,10);
		JTextField stereotyp = new JTextField(objekt_stereotyp,10);
		JTextField class_name = new JTextField(objekt_klasse,10);  //neu
		JTextField typvalue = new JTextField(objekt_eigenschaftswerte,25);
		
		//TextFields des Reiters "Attribute"
		JTextField attribute_name = new JTextField(10);
		JTextField datatyp = new JTextField(10);
		JTextField initial_value = new JTextField(25);
		JTextField attribute_assurance = new JTextField(25);
		
		//TextFields des Reiters "Methoden"
		JTextField method_name = new JTextField(10);
		JTextField returntyp = new JTextField(10);
		JTextField parameters = new JTextField(25);
		JTextField method_assurance = new JTextField(25);
		
		JButton info = new JButton("Info");
		JButton attribute_button1 = new JButton("Hinzufgen");
		JButton attribute_button2 = new JButton("Ersetzen");
		JButton attribute_button3 = new JButton("Lschen");
		
		JButton method_button1 = new JButton("Hinzufgen");
		JButton method_button2 = new JButton("Ersetzen");
		JButton method_button3 = new JButton("Lschen");
		
		JButton right_button1 = new JButton("Anzeigen");
		JButton right_button2 = new JButton("OK");
		JButton right_button3 = new JButton("Abbrechen");
		
		MyCanvas paint_canvas = new MyCanvas();
		
		JComboBox scope_attribute = new JComboBox();
		JComboBox scope_method = new JComboBox();
		JComboBox right_detail = new JComboBox();
		
		JTextArea text_area1 = new JTextArea(5, 15);
		
		ActionListener on_right_buttons = new RightButtonsListener();
		ActionListener on_methoden_buttons = new MethodenButtonsListener();
		ActionListener on_attribute_buttons = new AttributeButtonsListener();
		ListSelectionListener on_attribute_list_selections=new Attribute_ListSelectionListener();
		ListSelectionListener on_method_list_selections=new Methoden_ListSelectionListener();
		ActionListener on_right_detail = new RightDetailListener();
		
		//Construct the frame
		public Gui_Objekt()
		{
			enableEvents(AWTEvent.WINDOW_EVENT_MASK);
			try
			{
				init();
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		
		//Component initialization
		private void init()
		{
			
			this.setContentPane(content_pane);
			this.setSize(new Dimension(900,500));
			this.setTitle("Objekt editieren");
			this.setIconImage((new ImageIcon("brain.jpg")).getImage());
			
			content_pane.add(my_splitter);
			
			left.setLayout(new BorderLayout());
			right.setLayout(new BorderLayout());
						
			right.setPreferredSize(new Dimension(500,500));
			
			paint_canvas.setSize(new Dimension(500,475));
			paint_canvas.setBackground(new Color(255, 255, 255));
			
			scroll_attributes.setPreferredSize(new Dimension(350, 60));
			scroll_methods.setPreferredSize(new Dimension(350, 60));
			
			scope_attribute.setBackground(new Color(255, 255, 255));
			scope_attribute.addItem("public");
			scope_attribute.addItem("protected");
			scope_attribute.addItem("private");
			scope_attribute.addItem("void");
			scope_attribute.addItem("abstract");
			
			scope_method.setBackground(new Color(255, 255, 255));
			scope_method.addItem("public");
			scope_method.addItem("protected");
			scope_method.addItem("private");
			scope_method.addItem("void");
			scope_method.addItem("abstract");
			
			right_detail.setBackground(new Color(255, 255, 255));
			right_detail.setToolTipText("Detailierungsgrad");
			right_detail.addItem("Alles");
			right_detail.addItem("Name+Attribute");
			right_detail.addItem("Name+Methoden");
			right_detail.addItem("Name");
			
			one1.setLayout(new BorderLayout());
			one1.add(info, BorderLayout.EAST);
			one1.add(one11, BorderLayout.WEST);
			
			one11.setLayout(new GridLayout(2,2));
			one11.add(new JLabel("Objektname:"));
			one11.add(new JLabel("Stereotyp:"));
			one11.add(new JLabel("Klasse:"));
			one11.add(object_name);
			one11.add(stereotyp);
			one11.add(class_name);
			
			one2.setLayout(new BorderLayout());
			one2.add(new JLabel("Eigenschaftswerte:"), BorderLayout.WEST);
			one2.add(typvalue, BorderLayout.EAST);
			
			oneall.setLayout(new BorderLayout());
			oneall.setBorder(new TitledBorder("Allgemein"));
			oneall.add(one1, BorderLayout.CENTER);
			oneall.add(one2, BorderLayout.SOUTH);
			
			two1.setLayout(new GridLayout(2,3));
			two1.add(new JLabel("Attributname:"));
			two1.add(new JLabel("Gltigkeitsbereich:"));
			two1.add(new JLabel("Datentyp:"));
			two1.add(attribute_name);
			two1.add(scope_attribute);
			two1.add(datatyp);
			
			two21.setLayout(new BorderLayout());
			two21.add(new JLabel("Attributwert:"), BorderLayout.WEST);
			two21.add(initial_value, BorderLayout.EAST);
			
			two22.setLayout(new BorderLayout());
			two22.add(new JLabel("Zusicherungen:"), BorderLayout.WEST);
			two22.add(attribute_assurance, BorderLayout.EAST);
			
			two2.setLayout(new BorderLayout());
			two2.add(two21, BorderLayout.NORTH);
			two2.add(two22, BorderLayout.CENTER);
			
			two31.setLayout(new GridLayout(0,3));
			two31.add(attribute_button1);
			two31.add(attribute_button2);
			two31.add(attribute_button3);
			
			two3.setLayout(new BorderLayout());
			two3.add(scroll_attributes, BorderLayout.NORTH);
			two3.add(two31, BorderLayout.SOUTH);
			
			twoall.setLayout(new BorderLayout());
			twoall.setBorder(new TitledBorder("Attribute"));
			twoall.add(two1, BorderLayout.NORTH);
			twoall.add(two2, BorderLayout.CENTER);
			twoall.add(two3, BorderLayout.SOUTH);
			
			three1.setLayout(new GridLayout(2,3));
			three1.add(new JLabel("Methodenname:"));
			three1.add(new JLabel("Gltigkeitsbereich:"));
			three1.add(new JLabel("Rckgabetyp:"));
			three1.add(method_name);
			three1.add(scope_method);
			three1.add(returntyp);
			
			three21.setLayout(new BorderLayout());
			three21.add(new JLabel("Parameter:"), BorderLayout.WEST);
			three21.add(parameters, BorderLayout.EAST);
			
			three22.setLayout(new BorderLayout());
			three22.add(new JLabel("Zusicherungen:"), BorderLayout.WEST);
			three22.add(method_assurance, BorderLayout.EAST);
			
			three2.setLayout(new BorderLayout());
			three2.add(three21, BorderLayout.NORTH);
			three2.add(three22, BorderLayout.CENTER);
			
			three31.setLayout(new GridLayout(0,3));
			three31.add(method_button1);
			three31.add(method_button2);
			three31.add(method_button3);
			
			three3.setLayout(new BorderLayout());
			three3.add(scroll_methods, BorderLayout.NORTH);
			three3.add(three31, BorderLayout.SOUTH);
			
			threeall.setLayout(new BorderLayout());
			threeall.setBorder(new TitledBorder("Methoden"));
			threeall.add(three1, BorderLayout.NORTH);
			threeall.add(three2, BorderLayout.CENTER);
			threeall.add(three3, BorderLayout.SOUTH);
			
			left.add(oneall, BorderLayout.NORTH);
			left.add(twoall, BorderLayout.CENTER);
			left.add(threeall, BorderLayout.SOUTH);
			
			right_buttons.setLayout(new GridLayout(0, 4));
			right_buttons.add(right_button1);
			right_buttons.add(right_detail);
			right_buttons.add(right_button2);
			right_buttons.add(right_button3);
			
			right.add(paint_canvas, BorderLayout.NORTH);
			right.add(right_buttons, BorderLayout.SOUTH);
			
			if(!(objekt_attribute.size()==0))
			{
				Attribut x=new Attribut();
				for(int i=0;i<objekt_attribute.size();i++)
				{									
					x=(Attribut) objekt_attribute.get(i);
					my_attributes.addElement(x.attribut_gueltigkeit+" "+x.attribut_datentyp+" "+x.attribut_name+" "+
						x.attribut_attributwert+" {"+x.attribut_zusicherung+"}");
				}				                          
				attribute_list.updateUI();									 
			}	
			
			if(!(objekt_methoden.size()==0))
			{
				Methode x=new Methode();
				for(int i=0;i<objekt_methoden.size();i++)
				{									
					x=(Methode) objekt_methoden.get(i);
					my_methods.addElement(x.methode_gueltigkeit+" "+x.methode_rueckgabetyp+" "+x.methode_name+
						"("+x.methode_parameter+") "+"{"+x.methode_zusicherung+"}");				                         
				}				                          
				method_list.updateUI();									 
			}	
			//ButtonActionListeners
			info.addActionListener(on_right_buttons);
			right_button1.addActionListener(on_right_buttons);
			right_button2.addActionListener(on_right_buttons);
			right_button3.addActionListener(on_right_buttons);
			
			attribute_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			attribute_list.addListSelectionListener(on_attribute_list_selections);
			method_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			method_list.addListSelectionListener(on_method_list_selections);
			
			right_detail.addActionListener(on_right_detail);
			method_button1.addActionListener(on_methoden_buttons);
			method_button2.addActionListener(on_methoden_buttons);
			method_button3.addActionListener(on_methoden_buttons);
			attribute_button1.addActionListener(on_attribute_buttons);
			attribute_button2.addActionListener(on_attribute_buttons);
			attribute_button3.addActionListener(on_attribute_buttons);
			
		}
		
		class MethodenButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if (e.getActionCommand()=="Hinzufgen")
				{
					//zum AnzeigeVectorfrdieAttribute hinzufgen und list.update() ausfhren => anzeige
					my_methods.addElement(scope_method.getSelectedItem().toString()+" "+returntyp.getText()+						
						" "+method_name.getText()+"("+parameters.getText()+")"+
						" {"+method_assurance.getText()+"}");
					method_list.updateUI();
					
					/*falsche Anordung
					my_methods.addElement(scope_method.getSelectedItem().toString()+
					" "+method_name.getText()+"("+parameters.getText()+ ":"+ returntyp.getText()+ ")"+
					" {"+method_assurance.getText()+"}");
					method_list.updateUI();
					*/
					
					//interne Speicherung der Attribute
					//Bem:pos von attribute_Vektor = pos von Anzeige_Vektor
					Methode aktuelle_Methode=new Methode();
					aktuelle_Methode.methode_name=method_name.getText();
					aktuelle_Methode.methode_gueltigkeit=scope_method.getSelectedItem().toString();
					aktuelle_Methode.methode_rueckgabetyp=returntyp.getText();
					aktuelle_Methode.methode_parameter=parameters.getText();
					aktuelle_Methode.methode_zusicherung=method_assurance.getText();
					objekt_methoden.addElement(aktuelle_Methode);
					
					//Textfields lschen,fr neue Eingabe
					method_name.setText("");
					returntyp.setText("");
					parameters.setText("");
					method_assurance.setText("");
					//Combobox Scope auf Initialwert=public setzen
					scope_method.setSelectedIndex(0);
				}
                                if (e.getActionCommand()=="Ersetzen")
				{
					if(!method_list.isSelectionEmpty())
					{   //interne Speicherung der Attribute
						//Bem:pos von attribute_Vektor = pos von Anzeige_Vektor
						Methode aktuelle_Methode=new Methode();
						aktuelle_Methode.methode_name=method_name.getText();
						aktuelle_Methode.methode_gueltigkeit=scope_method.getSelectedItem().toString();
						aktuelle_Methode.methode_rueckgabetyp=returntyp.getText();
						aktuelle_Methode.methode_parameter=parameters.getText();
						aktuelle_Methode.methode_zusicherung=method_assurance.getText();
						objekt_methoden.setElementAt(aktuelle_Methode,method_list.getSelectedIndex());

						//im Vector ersetzen und list.updateUI() ausfhren => anzeige

						my_methods.setElementAt((scope_method.getSelectedItem().toString()+" "+returntyp.getText()+
						" "+method_name.getText()+"("+parameters.getText()+")"+
						" {"+method_assurance.getText()+"}"),method_list.getSelectedIndex());
						method_list.updateUI();
						method_list.clearSelection();

						/*falsche Anordnung
						my_methods.setElementAt((scope_method.getSelectedItem().toString()+" "+
							" "+method_name.getText()+"("+parameters.getText()+ ":"+returntyp.getText()+")"+
							" {"+method_assurance.getText()+"}"),method_list.getSelectedIndex());
						*/


						//Textfields lschen,fr neue Eingabe
						method_name.setText("");
						returntyp.setText("");
						parameters.setText("");
						method_assurance.setText("");
						//Combobox Scope auf Initialwert=public setzen
						scope_method.setSelectedIndex(0);
					}
                                        else
                               		{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Markieren Sie zuerst die zu ersetzende Methode!");
					}
				}
				if (e.getActionCommand()=="Lschen")
				{
					if(!method_list.isSelectionEmpty())
					{
						objekt_methoden.removeElementAt(method_list.getSelectedIndex());//Vektor von Klasse "Klasse", er enthlt Attribut-Objekte
						objekt_methoden.trimToSize();
						my_methods.removeElementAt(method_list.getSelectedIndex());//Vektor von Klasse "Gui_Klasse", er enthlt Strings fr die Anzeige
						my_methods.trimToSize();
						//Textfields lschen,fr neue Eingabe
						method_name.setText("");
						returntyp.setText("");
						parameters.setText("");
						method_assurance.setText("");
						//Combobox Scope auf Initialwert=public setzen
						scope_method.setSelectedIndex(0);
						method_list.updateUI();
						method_list.clearSelection();
					}
                                        else
					{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Bitte zu lschende Methode in der Liste markieren!");
					}
				}
			}
		}

		class AttributeButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if (e.getActionCommand()=="Hinzufgen")
				{
					//interne Speicherung der Attribute
					//Bem:pos von attribute_Vektor = pos von Anzeige_Vektor
					Attribut aktuelles_Attribut=new Attribut();
					aktuelles_Attribut.attribut_name=attribute_name.getText();
					aktuelles_Attribut.attribut_gueltigkeit=scope_attribute.getSelectedItem().toString();
					aktuelles_Attribut.attribut_datentyp=datatyp.getText();
					aktuelles_Attribut.attribut_attributwert=initial_value.getText();
					aktuelles_Attribut.attribut_zusicherung=attribute_assurance.getText();
					objekt_attribute.addElement(aktuelles_Attribut);

					//zum AnzeigeVectorfrdieAttribute hinzufgen und list.update() ausfhren => anzeige
					my_attributes.addElement(scope_attribute.getSelectedItem().toString()+" "+datatyp.getText()+
						" "+attribute_name.getText()+" = "+initial_value.getText()+
						" {"+attribute_assurance.getText()+"}");
					attribute_list.updateUI();
					
					
					//Textfields lschen,fr neue Eingabe
					attribute_name.setText("");
					datatyp.setText("");
					initial_value.setText("");
					attribute_assurance.setText("");
					//Combobox Scope auf Initialwert=public setzen
					scope_attribute.setSelectedIndex(0);
				}
                                if (e.getActionCommand()=="Ersetzen")
				{
					if(!attribute_list.isSelectionEmpty())
					{       //interne Speicherung der Attribute
						//Bem:pos von attribute_Vektor = pos von Anzeige_Vektor
						Attribut aktuelles_Attribut=new Attribut();
						aktuelles_Attribut.attribut_name=attribute_name.getText();
						aktuelles_Attribut.attribut_gueltigkeit=scope_attribute.getSelectedItem().toString();
						aktuelles_Attribut.attribut_datentyp=datatyp.getText();
						aktuelles_Attribut.attribut_attributwert=initial_value.getText();
						aktuelles_Attribut.attribut_zusicherung=attribute_assurance.getText();
						objekt_attribute.setElementAt(aktuelles_Attribut,attribute_list.getSelectedIndex());

						//im Vector ersetzen und list.update() ausfhren => anzeige
						my_attributes.setElementAt((scope_attribute.getSelectedItem().toString()+" "+datatyp.getText()+
							" "+attribute_name.getText()+" = "+initial_value.getText()+
							" {"+attribute_assurance.getText()+"}"),attribute_list.getSelectedIndex());
						attribute_list.updateUI();
						attribute_list.clearSelection();



						//Textfields lschen,fr neue Eingabe
						attribute_name.setText("");
						datatyp.setText("");
						initial_value.setText("");
						attribute_assurance.setText("");
						//Combobox Scope auf Initialwert=public setzen
						scope_attribute.setSelectedIndex(0);
					}
                                       else
				       {
				                JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Markieren Sie zuerst das zu ersetzende Attribut!");
				       }
				}

				if (e.getActionCommand()=="Lschen")//beim Aufrufen kommt ArrayIndexOUtOfBoundsException, wieso wei ich nicht, aber alles luft weiter...
				{
					if(!attribute_list.isSelectionEmpty())
					{
						objekt_attribute.removeElementAt(attribute_list.getSelectedIndex());//Vektor von Klasse "Klasse", er enthlt Attribut-Objekte
						objekt_attribute.trimToSize();
						my_attributes.removeElementAt(attribute_list.getSelectedIndex());//Vektor von Klasse "Gui_Klasse", er enthlt Strings fr die Anzeige
						my_attributes.trimToSize();
						//Textfields lschen,fr neue Eingabe
						attribute_name.setText("");
						datatyp.setText("");
						initial_value.setText("");
						attribute_assurance.setText("");
						//Combobox Scope auf Initialwert=public setzen
						scope_attribute.setSelectedIndex(0);
						attribute_list.updateUI();
						attribute_list.clearSelection();
					}
                                        else
					{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Bitte zu lschendes Attribut in der Liste markieren!");
					}
				}
			}
		}

		public class Attribute_ListSelectionListener implements ListSelectionListener
		{
			public void valueChanged(ListSelectionEvent e)
			{
				if(attribute_list.getSelectedIndex()!=-1)
				{
					attribute_name.setText(((Attribut) objekt_attribute.get(attribute_list.getSelectedIndex())).attribut_name);
					datatyp.setText(((Attribut) objekt_attribute.get(attribute_list.getSelectedIndex())).attribut_datentyp);
					initial_value.setText(((Attribut) objekt_attribute.get(attribute_list.getSelectedIndex())).attribut_attributwert);
					attribute_assurance.setText(((Attribut) objekt_attribute.get(attribute_list.getSelectedIndex())).attribut_zusicherung);
					scope_attribute.setSelectedItem(((Attribut) objekt_attribute.get(attribute_list.getSelectedIndex())).attribut_gueltigkeit);
				}
			}
		}
		
		public class Methoden_ListSelectionListener implements ListSelectionListener
		{
			public void valueChanged(ListSelectionEvent e)
			{
				if(method_list.getSelectedIndex()!=-1)
				{
					method_name.setText(((Methode) objekt_methoden.get(method_list.getSelectedIndex())).methode_name);
					returntyp.setText(((Methode) objekt_methoden.get(method_list.getSelectedIndex())).methode_rueckgabetyp);
					parameters.setText(((Methode) objekt_methoden.get(method_list.getSelectedIndex())).methode_parameter);
					method_assurance.setText(((Methode) objekt_methoden.get(method_list.getSelectedIndex())).methode_zusicherung);
					scope_method.setSelectedItem(((Methode) objekt_methoden.get(method_list.getSelectedIndex())).methode_gueltigkeit);
				}
			}
		}
		public class RightDetailListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(right_detail.getSelectedItem()=="Alles")
				{
					paint_canvas.repaint();
				}
				if(right_detail.getSelectedItem()=="Name+Attribute")
				{
					paint_canvas.repaint();
				}
				if(right_detail.getSelectedItem()=="Name+Methoden")
				{
					paint_canvas.repaint();
				}
				if(right_detail.getSelectedItem()=="Name")
				{
					paint_canvas.repaint();
				}
			}
		}
		
		public class RightButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{	
				if(e.getActionCommand()=="Info")
				{ 
					if (objekt_info_offen==false)
					{
						objekt_info.info_name = object_name.getText();
						objekt_info_offen=true;						
						objekt_info.edit("Informationen des Objekts: "+objekt_info.info_name,"objekt");
					}
					else
					{;
					}
				}
				
                                if(e.getActionCommand()=="Anzeigen")
				{
                                        objekt = object_name.getText();
                                        stereo = stereotyp.getText();
                                        klasse = class_name.getText();
                                        eigen = typvalue.getText();

                                        if(objekt.length() != 0)
                                        {
                                                paint_canvas.repaint();
					}
                                        else
					{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Bitte geben Sie einen Objektnamen ein!");
					}
                                }
				
				if(e.getActionCommand()=="OK")
				{ 
					//interne Speicherung von Name,Stereo,Eigenschaftswerte
					//methoden und attribute werden ja schon durch hinzufgen bzw. ersetzen intern gespeichert
					//Gui_CaseTool.objekt_offen=false;
					objekt_info.info_name=object_name.getText();
					objekt_stereotyp=stereotyp.getText();
					objekt_klasse=class_name.getText();
					objekt_eigenschaftswerte=typvalue.getText();					
					
					/**/
					fc.setDialogTitle("Objekt speichern");
					File default_file=new File(objekt_info.filename);
					fc.setSelectedFile(default_file);
					int returnVal =fc.showSaveDialog(Gui_Objekt.this);
					if(returnVal == JFileChooser.APPROVE_OPTION)
					{						
						try
						{							
							File file = fc.getSelectedFile();
							save(file);	
							UMLTOPP.objekt_offen=false;
							dispose();
						}
						catch(Exception f)
						{
							JOptionPane test = new JOptionPane();
							test.showMessageDialog(getParent(), f.getMessage(),"Fehlermeldung",JOptionPane.ERROR_MESSAGE);
						}
					}	
					/**/					
				}
				
        if(e.getActionCommand()=="Abbrechen")
        {
        Object[] test = { "OK", "CANCEL" };
        JOptionPane jop = new JOptionPane();
        int inputvalue = jop.showOptionDialog(null, "Abbrechen ohne zu speichern? Daten knnen verloren gehen!", "Warning",JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, test, test[0]);
        
        if(inputvalue == JOptionPane.OK_OPTION)
          {
          UMLTOPP.objekt_offen=false;
          dispose();
          }
        }
      }
    }    
		//Overridden so we can exit when window is closed
		protected void processWindowEvent(WindowEvent e)
		{
			super.processWindowEvent(e);
			if (e.getID() == WindowEvent.WINDOW_CLOSING)
			{
				UMLTOPP.objekt_offen=false;
				this.dispose();
			}
		}
		
		public class MyCanvas extends Canvas
		{
			int maxattribut;
			int maxmethode;
			
			MyCanvas()
			{
				setBackground(Color.white);
				setForeground(Color.black);
			}
			
			public void paint(Graphics g)
			{
				
				if(objekt.length() > 0)
				{
					//WENN DER DETAILLIERUNGSGRAD NAME GEWHLT IST     
					if(right_detail.getSelectedItem()=="Name")
					{
						
						int j=this.getFontMetrics(this.getFont()).stringWidth(objekt);
						int max;
						if(klasse.length()>0){max=j+this.getFontMetrics(this.getFont()).stringWidth(" : "+klasse);}
						else{max=0;}
						int maxstereo;
						if(stereo.length()>0){maxstereo=this.getFontMetrics(this.getFont()).stringWidth("<<"+stereo+">>");}
						else{maxstereo=0;}
						int maxeigen;
						if(eigen.length()>0){maxeigen=this.getFontMetrics(this.getFont()).stringWidth("{"+eigen+"}");}
						else{maxeigen=0;}
						int maximum=Math.max((Math.max((Math.max(j,max)),maxstereo)),maxeigen);
						g.drawRect(50,50,maximum+10,55);
						g.drawString(objekt,55,80);
						g.drawLine(55,82,55+j,82);
						if(klasse.length() > 0)
						{
							g.drawString(" : "+klasse,55+j,80);
						}
						
						if(stereo.length() > 0)
						{
							g.drawString("<<"+stereo+">>",55,65);
						}
						if(eigen.length() > 0)
						{
							g.drawString("{"+eigen+"}",55,95);
						}
					}
					//WENN DER DETAILLIERUNGSGRAD NAME+ATTRIBUTE GEWHLT IST
					if((objekt_attribute.isEmpty()==false)&&
						(right_detail.getSelectedItem()=="Name+Attribute"))
					{   //Berechnet die maximale Lnge des obersten Abschnitts der KLasse
						int j=this.getFontMetrics(this.getFont()).stringWidth(objekt);
						int max;
						if(klasse.length()>0){max=j+this.getFontMetrics(this.getFont()).stringWidth(" : "+klasse);}
						else{max=0;}
						int maxstereo;
						if(stereo.length()>0){maxstereo=this.getFontMetrics(this.getFont()).stringWidth("<<"+stereo+">>");}
						else{maxstereo=0;}
						int maxeigen;
						if(eigen.length()>0){maxeigen=this.getFontMetrics(this.getFont()).stringWidth("{"+eigen+"}");}
						else{maxeigen=0;}
						int maxname=Math.max((Math.max((Math.max(j,max)),maxstereo)),maxeigen);
						//Berechnet die maximale Lnge des Attributabschnitts
						int c=0;
						int test =0;
						for(int i=1;i<=objekt_attribute.size();i++)
						{
							maxattribut=Math.max(this.getFontMetrics(this.getFont()).stringWidth( (( (Attribut) objekt_attribute.get(c)).attribut_gueltigkeit)+ " "+
								(( (Attribut)objekt_attribute.get(c)).attribut_datentyp)+ " " +(( (Attribut)objekt_attribute.get(c)).attribut_name)+ " = " +
								(( (Attribut)objekt_attribute.get(c)).attribut_attributwert)+ " { " +(( (Attribut)objekt_attribute.get(c)).attribut_zusicherung) +" } "),test);
							test=maxattribut;                                  
							c++;
						} 	
						
						//Berechnet, ob die Attribute oder die Namen lnger sind!
						int maximum1 =Math.max(maxname,maxattribut);
						//Zeichnet den oberen Teil mit Name etc.
						g.drawRect(50,50,maximum1+10,55);
						g.drawString(objekt,55,80);
						g.drawLine(55,82,55+j,82);
						if(klasse.length() > 0)
						{
							g.drawString(" : "+klasse,55+j,80);
						}
						
						if(stereo.length() > 0)
						{
							g.drawString("<<"+stereo+">>",55,65);
						}
						if(eigen.length() > 0)
						{
							g.drawString("{"+eigen+"}",55,95);
						}
						
						//Zeichnet den Attributteil   
						int k=0;
						int x=0;
						for(int i=1;i<=objekt_attribute.size();i++)
						{
							g.drawRect(50,105,maximum1+10,(objekt_attribute.size()*15)+5);
							g.drawString(  (( (Attribut) objekt_attribute.get(k)).attribut_gueltigkeit)+ " " +
								(( (Attribut) objekt_attribute.get(k)).attribut_datentyp)+  " " +
								(( (Attribut) objekt_attribute.get(k)).attribut_name)+ " = " +
								(( (Attribut) objekt_attribute.get(k)).attribut_attributwert)+ " { " +
								(( (Attribut) objekt_attribute.get(k)).attribut_zusicherung)+" } ",55,120+x);
							k++;
							x=x+15;
						}
						
					}
					
					//WENN DER DETAILLIERUNGSGRAD NAME+METHODEN GEWHLT IST
					if((objekt_methoden.isEmpty()==false)&&
						(right_detail.getSelectedItem()=="Name+Methoden"))
					{
						//Berechnet die maximale Lnge des obersten Abschnitts der KLasse
						int j=this.getFontMetrics(this.getFont()).stringWidth(objekt);
						int max;
						if(klasse.length()>0){max=j+this.getFontMetrics(this.getFont()).stringWidth(" : "+klasse);}
						else{max=0;}
						int maxstereo;
						if(stereo.length()>0){maxstereo=this.getFontMetrics(this.getFont()).stringWidth("<<"+stereo+">>");}
						else{maxstereo=0;}
						int maxeigen;
						if(eigen.length()>0){maxeigen=this.getFontMetrics(this.getFont()).stringWidth("{"+eigen+"}");}
						else{maxeigen=0;}
						int maxname=Math.max((Math.max((Math.max(j,max)),maxstereo)),maxeigen);
						//Berechnet die maximale Lnge des Methodenabschnitts
						int c=0;
						int test =0;
						for(int i=1;i<=objekt_methoden.size();i++)
						{
							maxmethode=Math.max(this.getFontMetrics(this.getFont()).stringWidth( (( (Methode) objekt_methoden.get(c)).methode_gueltigkeit)+ " "+
								(( (Methode)objekt_methoden.get(c)).methode_name)+ "(" +(( (Methode)objekt_methoden.get(c)).methode_parameter)+ ":" +
								(( (Methode)objekt_methoden.get(c)).methode_rueckgabetyp)+ ")"+" {" +(( (Methode)objekt_methoden.get(c)).methode_zusicherung) +" } "),test);
							test=maxmethode;                                  
							c++;
							
						} 	
						
						//Berechnet, ob die Attribute oder die Namen lnger sind!
						int maximum2 =Math.max(maxname,maxmethode);
						//Zeichnet den oberen Abschnitt mit Name etc.
						g.drawRect(50,50,maximum2+10,55);
						g.drawString(objekt,55,80);
						g.drawLine(55,82,55+j,82);
						if(klasse.length() > 0)
						{
							g.drawString(" : "+klasse,55+j,80);
						}
						
						if(stereo.length() > 0)
						{
							g.drawString("<<"+stereo+">>",55,65);
						}
						if(eigen.length() > 0)
						{
							g.drawString("{"+eigen+"}",55,95);
						}
						
						
						//Zeichnet den Methodenteil
						int k=0;
						int x=0;
						for(int i=1;i<=objekt_methoden.size();i++)
						{
							g.drawRect(50,105,maximum2+10,(objekt_methoden.size()*15)+5);
							g.drawString(  (((Methode) objekt_methoden.get(k)).methode_gueltigkeit)+" "+
								(( (Methode) objekt_methoden.get(k)).methode_name)+"("+
								(( (Methode) objekt_methoden.get(k)).methode_parameter)+":"+
								(( (Methode) objekt_methoden.get(k)).methode_rueckgabetyp)+")" +" {"+
								(( (Methode) objekt_methoden.get(k)).methode_zusicherung)+"}",55,120+x);
							k++;
							x=x+15;
						}
					}
					//WENN DER DETAILLIERUNGSGRAD ALLES GEWHLT IST
					if(right_detail.getSelectedItem()=="Alles")
					{
						//Berechnet die maximale Lnge des obersten Abschnitts der KLasse
						int j=this.getFontMetrics(this.getFont()).stringWidth(objekt);
						int max;
						if(klasse.length()>0){max=j+this.getFontMetrics(this.getFont()).stringWidth(" : "+klasse);}
						else{max=0;}
						int maxstereo;
						if(stereo.length()>0){maxstereo=this.getFontMetrics(this.getFont()).stringWidth("<<"+stereo+">>");}
						else{maxstereo=0;}
						int maxeigen;
						if(eigen.length()>0){maxeigen=this.getFontMetrics(this.getFont()).stringWidth("{"+eigen+"}");}
						else{maxeigen=0;}
						int maxname=Math.max((Math.max((Math.max(j,max)),maxstereo)),maxeigen);
						
						//Berechnet die maximale Lnge des Attributabschnitts
						//int maximum;
						if(objekt_attribute.isEmpty()==false)       		
						{
							int c=0;
							int test =0;
							for(int i=1;i<=objekt_attribute.size();i++)
							{
								maxattribut=Math.max(this.getFontMetrics(this.getFont()).stringWidth( (( (Attribut) objekt_attribute.get(c)).attribut_gueltigkeit)+ " "+
									(( (Attribut)objekt_attribute.get(c)).attribut_datentyp)+ " " +(( (Attribut)objekt_attribute.get(c)).attribut_name)+ " = " +
									(( (Attribut)objekt_attribute.get(c)).attribut_attributwert)+ " { " +(( (Attribut)objekt_attribute.get(c)).attribut_zusicherung) +" } "),test);
								test=maxattribut;                                  
								c++;
							}
						}  	
						else{maxattribut=0;}
						//Berechnet die maximale Lnge des Methodenabschnitts
						if(objekt_methoden.isEmpty()==false)
						{
							int c=0;
							int test =0;
							for(int i=1;i<=objekt_methoden.size();i++)
							{
								maxmethode=Math.max(this.getFontMetrics(this.getFont()).stringWidth( (( (Methode) objekt_methoden.get(c)).methode_gueltigkeit)+ " "+
									(( (Methode)objekt_methoden.get(c)).methode_name)+ "(" +(( (Methode)objekt_methoden.get(c)).methode_parameter)+ ":" +
									(( (Methode)objekt_methoden.get(c)).methode_rueckgabetyp)+ ")"+" {" +(( (Methode)objekt_methoden.get(c)).methode_zusicherung) +" } "),test);
								test=maxmethode;                                  
								c++;
							}
						}   
						else{maxmethode=0;}	
						//Berechnet, ob die Attribute oder die Namen lnger sind!
						int maximum3 =Math.max((Math.max(maxname,maxattribut)),maxmethode);
						
						//Zeichnet den oberen Abschnitt mit Name etc.
						g.drawRect(50,50,maximum3+10,55);
						g.drawString(objekt,55,80);
						g.drawLine(55,82,55+j,82);
						if(klasse.length() > 0)
						{
							g.drawString(" : "+klasse,55+j,80);
						}
						
						if(stereo.length() > 0)
						{
							g.drawString("<<"+stereo+">>",55,65);
						}
						if(eigen.length() > 0)
						{
							g.drawString("{"+eigen+"}",55,95);
						}
						//Zeichnet den Attributteil   
						int k=0;
						int x=0;
						for(int i=1;i<=objekt_attribute.size();i++)
						{
							g.drawRect(50,105,maximum3+10,(objekt_attribute.size()*15)+5);
							g.drawString(  (( (Attribut) objekt_attribute.get(k)).attribut_gueltigkeit)+ " " +
								(( (Attribut) objekt_attribute.get(k)).attribut_datentyp)+  " " +
								(( (Attribut) objekt_attribute.get(k)).attribut_name)+ " = " +
								(( (Attribut) objekt_attribute.get(k)).attribut_attributwert)+ " { " +
								(( (Attribut) objekt_attribute.get(k)).attribut_zusicherung)+" } ",55,120+x);
							k++;
							x=x+15;
						}
						
						
						//Zeichnet den Methodenteil
						int k2=0;
						int x2=0;
						for(int i=1;i<=objekt_methoden.size();i++)
						{
							g.drawRect(50,(objekt_attribute.size()*15)+110,maximum3+10,(objekt_methoden.size()*15)+5);
							g.drawString(  (((Methode) objekt_methoden.get(k2)).methode_gueltigkeit)+" "+
								(( (Methode) objekt_methoden.get(k2)).methode_name)+"("+
								(( (Methode) objekt_methoden.get(k2)).methode_parameter)+":"+
								(( (Methode) objekt_methoden.get(k2)).methode_rueckgabetyp)+")" +" {"+
								(( (Methode) objekt_methoden.get(k2)).methode_zusicherung)+"}",55,((objekt_attribute.size()*15)+5)+120+x2);
							k2++;
							x2=x2+15;
						}
					}					
				}
			}
		}//Ende der Canvas-Klasse		
	}//Ende der Klasse Gui_Objekt	
}//Ende Objekt


