//BrainStorm mkH

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import java.util.*;
import java.io.*;

class UseCase
{
	
	//Attribute
	static boolean usecase_info_offen;
	Info usecase_info;
	String usecase_nummer;
	Vector usecase_attribute;
	Vector usecase_attribute_text;
	
	//Konstruktor
	UseCase()
	{
		usecase_info_offen=false;
		usecase_info = new Info();
		usecase_nummer = "";
		usecase_attribute = new Vector(1,1);
		usecase_attribute_text = new Vector(1,1);
	}
	
	//Methode: editieren
	public void edit()
	{
		Gui_UseCase use_case_gui = new Gui_UseCase();
		use_case_gui.setVisible(true);
		use_case_gui.pack();
	}
	
	//Methode: save
	public void save(File filename) throws Exception
	{
		XML xmlobject=new XML();
		{
			xmlobject.writeTag("usecase",0);
			xmlobject.writeChar("\n");
			usecase_info.write(xmlobject);			// schreibe Header
			xmlobject.writeTag("body",2);
			xmlobject.writeChar("\n");
			xmlobject.writeTag("nummer",4);
			xmlobject.writeString(this.usecase_nummer);
			xmlobject.writeTag("/nummer",0);
			xmlobject.writeChar("\n");
			for (int count=0; count < usecase_attribute.size(); count++)
			{
				xmlobject.writeTag("eintrag",4);
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("bezeichnung",6);
				xmlobject.writeString( (String) usecase_attribute.get(count));
				xmlobject.writeTag("/bezeichnung",0);xmlobject.writeChar("\n");
				
				xmlobject.writeTag("text",6);
				xmlobject.writeString( (String) usecase_attribute_text.get(count));
				xmlobject.writeTag("/text",0);
				xmlobject.writeChar("\n");
				
				xmlobject.writeTag("/eintrag",4);
				xmlobject.writeChar("\n");
				
			} // for
			
			xmlobject.writeTag("/body",2);
			xmlobject.writeChar("\n");
			
			xmlobject.writeTag("/usecase",0);
			xmlobject.writeChar("\n");
			
			xmlobject.saveXml(filename);
		}
	}
	
	//Methode: laden
	public void load(File filename) throws Exception
  {
    XML xmlobject = new XML();
    String tag="";
    String mabezeichnung="";
    String matext="";
    
    usecase_info.filename=filename.getPath();
    
    xmlobject.loadXml(filename);
    tag=xmlobject.getTag();
    if(!tag.equals("usecase"))
      {
      throw new Exception("Diese Datei enthaelt keinen Use - Case!");
      }
      do
        {
        tag=xmlobject.getTag();
        if(tag.equals("header"))
          {
          usecase_info.read(xmlobject);
          }
        else
          {
          if(tag.equals("body"))
            {
            do
              {
              tag=xmlobject.getTag();
              if(tag.equals("nummer"))
                {
                if(!usecase_nummer.equals(""))
                  {
                  throw new Exception("Fehler in der XML-Datei: Doppeltes Tag <nummer>");
                  }
                else
                  {
                  usecase_nummer=xmlobject.getString("nummer");
                  }
                } //ende if(!tag.equals("nummer"))
              else
                {
                if(tag.equals("eintrag"))
                  {
                  mabezeichnung="";
                  matext="";
                  do
                    {
                    tag=xmlobject.getTag();
                    if(tag.equals("bezeichnung"))
                      {
                      if(!mabezeichnung.equals(""))
                        {
                        throw new Exception("In einem <eintrag>-Tag gibt es mehr als 1 <bezeichnung>-Tag, es ist aber nur 1 <bezeichnung>-Tag erlaubt");
                        }
                      else
                        {
                        mabezeichnung=xmlobject.getString("bezeichnung");
                        }
                      } //ende if(!bezeichnung.equals("");
                    else
                      {
                      if(tag.equals("text"))
                        {
                        if(!matext.equals(""))
                          {
                          throw new Exception("In einem <eintrag>-Tag gibt es mehr als 1 <text>-Tag, es ist aber nur 1 <text>-Tag erlaubt");
                          }
                        else
                          {
                          matext=xmlobject.getString("text");
                          }
                        } //ende if(tag.equals("text")
                      else
                        {
                        if(!tag.equals("/eintrag"))
                          {
                          xmlobject.skipTag(tag);
                          }
                        } //ende else (if not text)
                      } //ende else (if not bezeichnung)
                    } 
                  while(!tag.equals("/eintrag"));
                    usecase_attribute.add(mabezeichnung);
                    usecase_attribute_text.add(matext);
                  } //ende if(tag.equals("eintrag"))
                  else
                    {
                    if(!tag.equals("/body"))
                      {
                      xmlobject.skipTag(tag);
                      }
                    } //ende else (if not equals eintrag)
                  } //ende else (if not nummer)
                } 
              while(!tag.equals("/body"));
                } //ende if(tag.equals("body")
              } // ende else (if not header)
            }
          while(!tag.equals("/usecase"));
          edit();
          }
	
	//GUI
	class Gui_UseCase extends JFrame
	{
		final JFileChooser fc = new JFileChooser();
		
		JPanel content_pane = new JPanel();
		
		JPanel left = new JPanel();
		JPanel right = new JPanel();
		
		JSplitPane my_splitter = new JSplitPane(1, left, right);
		
		JPanel one1 = new JPanel();
		JPanel one11 = new JPanel();
		JPanel one12 = new JPanel();
		JPanel oneall = new JPanel();
		JPanel two1 = new JPanel();
		JPanel two2 = new JPanel();
		JPanel twoall = new JPanel();
		JPanel three = new JPanel();
		
		JPanel right_buttons = new JPanel();
		JPanel list_buttons = new JPanel();
		
		JPanel grid_the_list = new JPanel();
		
		Vector list_elements = new Vector(1,1);
		JList my_element_list = new JList(list_elements);
		JScrollPane scroll_list = new JScrollPane(my_element_list);
		JTextArea element_text = new JTextArea(13, 15);
		JScrollPane scroll_text = new JScrollPane(element_text);
		JTextField element_name = new JTextField(2);
		
		JButton info = new JButton("Info");
		JButton right_button1 = new JButton("Anzeigen");
		JButton right_button2 = new JButton("OK");
		JButton right_button3 = new JButton("Abbrechen");
		
		JButton add_button = new JButton("Neues Element");
		JButton delete_button = new JButton("Element lschen");
		JButton change_button = new JButton("Ersetzen");
		
		JComboBox beispiele = new JComboBox();
		
		ActionListener on_element_buttons = new ListButtonsListener();
		
		MyCanvas paint_canvas = new MyCanvas();
		
		//TextFields des Reiters "Allgemein"
		JTextField use_case_name = new JTextField(usecase_info.info_name, 15);
		JTextField use_case_number = new JTextField(usecase_nummer, 4);
		
		String my_text="";
		ListSelectionListener on_attribute_list_selections=new Attribute_ListSelectionListener();
		ActionListener on_right_buttons = new RightButtonsListener();
		ActionListener on_list_buttons = new ListButtonsListener();
		ActionListener beispielcombo = new ComboListener();
		
		//Construct the frame
		public Gui_UseCase()
		{
			enableEvents(AWTEvent.WINDOW_EVENT_MASK);
			try
			{
				init();
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
		
		//Component initialization
		private void init()
		{
			this.setContentPane(content_pane);
			this.setSize(new Dimension(820,520));
			this.setTitle("Eingabe der Informationen zum Use-Case");
			this.setIconImage((new ImageIcon("brain.jpg")).getImage());
			
			content_pane.add(my_splitter);
			
			left.setLayout(new BorderLayout());
			right.setLayout(new BorderLayout());
			
			paint_canvas.setSize(new Dimension(400,515));
			paint_canvas.setBackground(new Color(255, 255, 255));
			
			one1.setLayout(new BorderLayout());
			one1.add(one11, BorderLayout.WEST);
			one1.add(one12, BorderLayout.EAST);
			
			one11.setLayout(new BorderLayout());
			one11.add(new JLabel("Nr.:"), BorderLayout.NORTH);
			one11.add(use_case_number, BorderLayout.SOUTH);
			
			one12.setLayout(new BorderLayout());
			one12.add(new JLabel("Name des Use-Cases:"), BorderLayout.NORTH);
			one12.add(use_case_name, BorderLayout.SOUTH);
			
			oneall.setLayout(new BorderLayout());
			oneall.setBorder(new TitledBorder("Allgemein"));
			oneall.add(info, BorderLayout.EAST);
			oneall.add(one1, BorderLayout.WEST);
			
			list_buttons.setLayout(new GridLayout(1,3));
			list_buttons.add(add_button);
			list_buttons.add(delete_button);
			list_buttons.add(change_button);
			
			grid_the_list.setLayout(new GridLayout(0, 1));
			grid_the_list.add(scroll_list);
			grid_the_list.setPreferredSize(new Dimension(190,175));
			
			beispiele.setBackground(new Color(255, 255, 255));
			beispiele.addItem("Whlen...");
			beispiele.addItem("Akteur");
			beispiele.addItem("Vorbedingung");
			beispiele.addItem("Ablauf");
			beispiele.addItem("Nachbedingung");
			beispiele.addItem("Invarianten");
			beispiele.addItem("Ausnahmen");
			
			two1.setLayout(new GridLayout(6,0));
			two1.add(new JLabel(" Standardattribute:"));
			two1.add(beispiele);
			
			two2.setLayout(new GridLayout(0,2));
			two2.add(grid_the_list);
			two2.add(two1);
			
			twoall.setLayout(new BorderLayout());
			twoall.add(two2, BorderLayout.NORTH);
			twoall.add(list_buttons, BorderLayout.SOUTH);
			
			if(!(usecase_attribute.size()==0))
			{
				for(int i=0;i<usecase_attribute.size();i++)
				{
					list_elements.addElement(usecase_attribute.get(i));
				}
				my_element_list.updateUI();
			}
			
			three.setLayout(new BorderLayout());
			three.add(new JLabel("Attributsbezeichnung:"), BorderLayout.NORTH);
			three.add(element_name, BorderLayout.CENTER);
			three.add(scroll_text, BorderLayout.SOUTH);
			
			left.add(oneall, BorderLayout.NORTH);
			left.add(twoall, BorderLayout.CENTER);
			left.add(three, BorderLayout.SOUTH);
			
			right_buttons.setLayout(new GridLayout(0, 3));
			right_buttons.add(right_button1);
			right_buttons.add(right_button2);
			right_buttons.add(right_button3);
			
			right.add(paint_canvas, BorderLayout.NORTH);
			right.add(right_buttons, BorderLayout.SOUTH);
			
			add_button.addActionListener(on_element_buttons);
			delete_button.addActionListener(on_element_buttons);
			change_button.addActionListener(on_element_buttons);
			
			info.addActionListener(on_right_buttons);
			right_button1.addActionListener(on_right_buttons);
			right_button2.addActionListener(on_right_buttons);
			right_button3.addActionListener(on_right_buttons);
			
			scroll_list.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			scroll_list.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
			
			scroll_text.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			scroll_text.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
			
			my_element_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			my_element_list.addListSelectionListener(on_attribute_list_selections);
			beispiele.addActionListener(beispielcombo);
			
		}
		
		//Overridden so we can exit when window is closed
		protected void processWindowEvent(WindowEvent e)
		{
			super.processWindowEvent(e);
			if (e.getID() == WindowEvent.WINDOW_CLOSING)
			{
				UMLTOPP.usecase_offen=false;
				this.dispose();
			}
		}
		
		public class ComboListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(beispiele.getSelectedItem()=="Whlen...")
				{
					
				}
				if(beispiele.getSelectedItem()=="Akteur")
				{
					//Setzen des Textes in das Attributtextfeld
					element_name.setText("Akteur");
                                        element_text.setText("");
				}
				if(beispiele.getSelectedItem()=="Vorbedingung")
				{
					//Setzen des Textes in das Attributtextfeld
					element_name.setText("Vorbedingung");
                                        element_text.setText("");

				}
				if(beispiele.getSelectedItem()=="Ablauf")
				{
					//Setzen des Textes in das Attributtextfeld
					element_name.setText("Ablauf");
                                        element_text.setText("");
				}
				if(beispiele.getSelectedItem()=="Nachbedingung")
				{
					//Setzen des Textes in das Attributtextfeld
					element_name.setText("Nachbedingung");
                                        element_text.setText("");
				}
				if(beispiele.getSelectedItem()=="Invarianten")
				{
					//Setzen des Textes in das Attributtextfeld
					element_name.setText("Invarianten");
                                        element_text.setText("");
				}
				if(beispiele.getSelectedItem()=="Ausnahmen")
				{
					//Setzen des Textes in das Attributtextfeld
					element_name.setText("Ausnahmen");
                                        element_text.setText("");
				}
			}
		}
		
		
		public class ListButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(e.getActionCommand()=="Neues Element")
				{
					if((element_name.getText()).length()!=0)
					{
						
						//Darstellung in Liste
						list_elements.add(element_name.getText());
						my_element_list.updateUI();
						//interne Speicherung
						usecase_attribute.add(element_name.getText());
						usecase_attribute_text.add(element_text.getText());
						//Textfields lschen fr neue Eingabe
						element_name.setText("");
						element_text.setText("");
						//Combo-Box auf "whlen" setzen
						beispiele.setSelectedIndex(0);
					}
					
					else
					{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Bitte tragen Sie eine Attributsbezeichnung ein!");
					}
					
				}
				
				if(e.getActionCommand()=="Element lschen")
				{
					if(!my_element_list.isSelectionEmpty())
					{
						list_elements.removeElementAt(my_element_list.getSelectedIndex());
						list_elements.trimToSize();
						my_element_list.updateUI();
						usecase_attribute.removeElementAt(my_element_list.getSelectedIndex());
						usecase_attribute.trimToSize();
						usecase_attribute_text.removeElementAt(my_element_list.getSelectedIndex());
						usecase_attribute_text.trimToSize();
						//Textfields lschen fr neue Eingabe
						element_name.setText("");
						element_text.setText("");
						my_element_list.clearSelection();
					}
					else
					{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Bitte zu lschendes Objekt in der Liste markieren!");
					}
				}
                                if(e.getActionCommand()=="Ersetzen")
				{
					if(!my_element_list.isSelectionEmpty())
					{
						//interne Speicherung
						usecase_attribute.setElementAt(element_name.getText(),my_element_list.getSelectedIndex());
						usecase_attribute_text.setElementAt(element_text.getText(),my_element_list.getSelectedIndex());
						//Darstellung in Liste
						list_elements.setElementAt(element_name.getText(),my_element_list.getSelectedIndex());
						my_element_list.updateUI();
						my_element_list.clearSelection();
						//Textfields lschen fr neue Eingabe
						element_name.setText("");
						element_text.setText("");
					}
                                        else
					{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Bitte zuerst zu ersetzendes Use-Case markieren!");
					}
				}
				
			}
		}
		
		public class RightButtonsListener implements ActionListener
		{
			public void actionPerformed(ActionEvent e)
			{
				if(e.getActionCommand()=="Info")
				{
					usecase_info.info_name=use_case_name.getText();
					usecase_info.edit("Informationen des Use-Cases: "+usecase_info.info_name, "use-case");
				}
				
                                if(e.getActionCommand()=="Anzeigen")
                                {
					my_text = use_case_name.getText();

                                        if(my_text.length() != 0)
                                        {
                                        	paint_canvas.repaint();
                                        }
                                        else
					{
						JOptionPane test = new JOptionPane();
						test.showMessageDialog(getParent(), "Bitte geben Sie einen Namen fr den Use-Case an!");
					}
				}

				if(e.getActionCommand()=="OK")
				{
					usecase_nummer = use_case_number.getText();
					usecase_info.info_name = use_case_name.getText();
					
					fc.setDialogTitle("UseCase speichern");
					File default_file=new File(usecase_info.filename);
					fc.setSelectedFile(default_file);
					int returnVal =fc.showSaveDialog(Gui_UseCase.this);
					if(returnVal == JFileChooser.APPROVE_OPTION)
					{
						try
						{
							File file = fc.getSelectedFile();
							save(file);
							UMLTOPP.usecase_offen=false;
							dispose();
						}
						catch(Exception f)
						{
							JOptionPane test = new JOptionPane();
							test.showMessageDialog(getParent(), f.getMessage(),"Fehlermeldung",JOptionPane.ERROR_MESSAGE);
						}
					}
				}
				
				if(e.getActionCommand()=="Abbrechen")
				{
        Object[] test = { "OK", "CANCEL" };
        JOptionPane jop = new JOptionPane();
        int inputvalue = jop.showOptionDialog(null, "Abbrechen ohne zu speichern? Daten knnen verloren gehen!", "Warning",JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, test, test[0]);

        if(inputvalue == JOptionPane.OK_OPTION)
          {
          UMLTOPP.usecase_offen=false;
				  dispose();
          }
				}
			}
		}
		
		public class Attribute_ListSelectionListener implements ListSelectionListener
		{
			public void valueChanged(ListSelectionEvent e)
			{
				if(my_element_list.getSelectedIndex()!=-1)
				{
					element_name.setText( (String) usecase_attribute.get(my_element_list.getSelectedIndex()));
					element_text.setText( (String) usecase_attribute_text.get(my_element_list.getSelectedIndex()));
				}
			}
		}
		
		public class MyCanvas extends Canvas
		{
			int j=0;
			public MyCanvas()
			{
				setBackground(Color.white);
				setForeground(Color.black);
			}
			
			public void paint(Graphics g) throws NullPointerException
			{
				try {
					if(my_text.length() > 0)
					{
						j=this.getFontMetrics(this.getFont()).stringWidth(my_text);
						g.drawOval(50,50,j+10,25);
						g.drawString(my_text, 55,65);
					}
				}
				catch(NullPointerException e)
				{ System.out.println(""); }
				
			}
		}
	}
}//Ende UseCase

